Clock = newClass(null, {
	name: "widget.clock",
	title: "Яндекс.Часы",
	version: 1.010002,
	clid: {status: 46171, morda: 46172},
	require: ['Dates'],
	constructor: function(menu, behaviour) {
		var context = this;
		Wdgt.preferences.mode('show-holidays', 'instance-collection', 'true');
		Wdgt.preferences.mode('show-second', 'instance-collection', 'true');
		Wdgt.preferences.mode('gear', 'instance-collection', 'analog');

		y5.Classes.add(document.body, Wdgt.platform.os);
		y5.Classes.add(document.body, Wdgt.platform.name);
		y5.Classes.assign(document.body, 'standalone-application', /Version\/((10.[2-9]\d)|(1[1-9].\d\d)|([2-9]\d.\d\d))/.test(navigator.userAgent));

		this.mode = new Clock.Mode(this);
		
		// gears
		this.digital = new Clock.Digital(this);
		this.analog = new Clock.Analog(this);
		
		this.updateGear();
		
		this.tick = new Clock.Tick(this);

		var platform = Wdgt.platform.name;
		if(platform == 'dashboard') {
			new Wdgt.PreferencesButton(y5.Dom.$('preferences-button'), y5.Dom.$('normal'));
			y5.Events.observe('click', this.togglePreferences, y5.Dom.$('preferences-button'), true, this);
			y5.Events.observe('click', this.togglePreferences, y5.Dom.$('preferences-done'), true, this);
			widget.onshow = function() {context.reset.call(context);}
		}

		if(platform == 'opera') {
			window.onclick = window.onfocus = function() {context.reset.call(context);}
		}

		if (platform == 'sidebar') {
			y5.Dom.$('logo').onclick = function () {context.openYandexWebPage.call(context);}
			y5.Dom.$('update').onclick = function () {context.doUpdate.call(context);}
		} else {
			y5.Events.observe('mousedown', this.openYandexWebPage, y5.Dom.$('logo'), true, this);
			y5.Events.observe('click', this.doUpdate, y5.Dom.$('preferences-update-link'), true, this);
			y5.Events.observe('click', this.doUpdate, y5.Dom.$('update'), true, this);
			
			y5.Events.observe('click', this.skinSelectClick, y5.Dom.$('preferences-skin-select'), true, this);
		}
		new y5.Observer('update', this.onUpdate, this, true, this);
	},
	updateGear: function() {
		var gear = Wdgt.preferences.get('gear');
		this.gear = this[gear];
		this.mode.set('gear', gear);
		this.mode.set('mode', 'normal');
	},
	openYandexWebPage: function() {
		Wdgt.utils.openURL(Wdgt.address('morda'));
	},
	togglePreferences: function() {
		if(this.mode.get('mode') != 'preferences') {
			y5.Dom.$('preferences-status').innerHTML = 'Яндекс.Часы ' + Wdgt.update.getVersion() + '<br> &copy; 2008-' + (new Date()).getFullYear() + ' &laquo;Яндекс&raquo;';
			y5.Dom.$('preferences-feedback-link').onclick = function(){Wdgt.utils.openURL(Wdgt.feedbackUrl());return false;};
			y5.Dom.$('preferences-holidays-checkbox').checked = Wdgt.preferences.get('show-holidays') == 'true';
			y5.Dom.$('preferences-second-checkbox').checked = Wdgt.preferences.get('show-second') == 'true';
			
			
			
			
			y5.Classes.add(y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'skin-' + Wdgt.preferences.get('gear')), 'select');

			
			this.mode.set('mode', 'preferences');
		} else {
			Wdgt.preferences.set('show-holidays', y5.Dom.$('preferences-holidays-checkbox').checked ? 'true' : 'false');
			Wdgt.preferences.set('show-second', y5.Dom.$('preferences-second-checkbox').checked ? 'true' : 'false');
			Wdgt.preferences.set('gear', this.skinGetCurrent());
			//this.mode.set('mode', 'normal');
			this.updateGear();
			this.tick.reset();
		}
	},
	skinSelectClick: function(e) {
		var button = y5.Dom.getAncestor(e.target, 'div', 'skin-preview');
		if(!button)
			return;
		var container = button.parentNode;
		var selected = y5.Dom.getDescendant(container, 'div', 'select');
		y5.Classes.remove(selected, 'select');
		y5.Classes.add(button, 'select');
	},
	skinGetCurrent: function() {
		var button = y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'select');
		if(y5.Classes.test(button, 'skin-analog'))
			return 'analog';
		if(y5.Classes.test(button, 'skin-digital'))
			return 'digital';
	},
	reset: function() {
		this.tick.reset();
	},
	closePreferences: function() {
		if(this.mode.get('mode') == 'preferences')
			Wdgt.widget.mode.set('mode', 'normal');
		this.resetInterval();
	},
	onUpdate: function() {
		y5.Classes.assign(document.body, 'update', Wdgt.update.status.update);
	},
	doUpdate: function() {
		Wdgt.utils.openURL(Wdgt.update.status.url);
	}
});

Wdgt.Widget = Clock;
