Clock.Analog = newClass(null, {
	r: 2 * Math.PI / 360,
	themes: {
		'normal': {
			name: 'normal',
			background: 'kernel/images/clock/breguet/normal/background.png',
			center: {left: 64, top: 65},
			height: 129,
			width: 29,
			hands: [
				{name: 'hour', hand: {url: 'kernel/images/clock/breguet/normal/hour.png'}, shadow: {url: 'kernel/images/clock/breguet/normal/hour-shadow.png'}},
				{name: 'minute', hand: {url: 'kernel/images/clock/breguet/normal/minute.png'}, shadow: {url: 'kernel/images/clock/breguet/normal/minute-shadow.png'}},
				{name: 'second', hand: {url: 'kernel/images/clock/breguet/normal/second.png'}, shadow: {url: 'kernel/images/clock/breguet/normal/second-shadow.png'}}
			]
		},
		'xmas': {
			name: 'xmas',
			background: 'kernel/images/clock/breguet/xmas/background.png',
			center: {left: 64, top: 65},
			height: 129,
			width: 29,
			hands: [
				{name: 'hour', hand: {url: 'kernel/images/clock/breguet/xmas/hour.png'}, shadow: {url: 'kernel/images/clock/breguet/xmas/hour-shadow.png'}},
				{name: 'minute', hand: {url: 'kernel/images/clock/breguet/xmas/minute.png'}, shadow: {url: 'kernel/images/clock/breguet/xmas/minute-shadow.png'}},
				{name: 'second', hand: {url: 'kernel/images/clock/breguet/xmas/second.png'}, shadow: {url: 'kernel/images/clock/breguet/xmas/second-shadow.png'}}
			]
		},
		'new-year': {
			name: 'new-year',
			background: 'kernel/images/clock/breguet/new-year/background.png',
			center: {left: 64, top: 65},
			height: 129,
			width: 29,
			hands: [
				{name: 'hour', hand: {url: 'kernel/images/clock/breguet/new-year/hour.png'}, shadow: {url: 'kernel/images/clock/breguet/new-year/hour-shadow.png'}},
				{name: 'minute', hand: {url: 'kernel/images/clock/breguet/new-year/minute.png'}, shadow: {url: 'kernel/images/clock/breguet/new-year/minute-shadow.png'}},
				{name: 'second', hand: {url: 'kernel/images/clock/breguet/new-year/second.png'}, shadow: {url: 'kernel/images/clock/breguet/new-year/second-shadow.png'}}
			]
		}
	},
	constructor: function(owner, theme) {
		this.owner = owner;
		this.current = null;
		this.platform = Wdgt.platform.name;
		this.stage = 0;
		this.start = true;
		this.applyTheme(this.themes['normal']);
		this.interval_tick = 0;
		this.prepare();
		this.a = 0;
		
		new y5.Observer('tick', this.tick, this, true, this);
	},
	applyTheme: function(theme) {
		//if(this.theme)
		//	y5.Classes.remove(document.body, 'theme-' + this.theme.name);
			document.body.className = y5.Strings.normalizeSpace(document.body.className.replace(new RegExp('' + 'theme' + '-(\\S+)', 'g'), ''));
		this.theme = theme;
		
		y5.Classes.add(document.body, 'theme-' + this.theme.name);
		this.owner.mode.redraw();
		
		for(var i = 0; i < this.theme.hands.length; i ++) {
			var hand = this.theme.hands[i];
			this.initImage(hand.shadow, hand.name, 'shadow');
			this.initImage(hand.hand, hand.name, 'hand');
		}
	},
	initImage: function(hand, name, type) {
		if (this.platform == 'sidebar') {
			var id = 'hand-' + name + '-' + type;
			if (y5.Dom.$(id))
				hand.image = y5.Dom.$(id);
			if (!hand.image) {
				hand.image = document.createElement('g:image');
				hand.image.id = id;
				hand.image.style.position = 'absolute';
				hand.image.style.left = (50 + (type == 'hand' ? 0 : 1 )) + 'px';;
				hand.image.style.top = (type == 'hand' ? 0 : 1 ) + 'px';
				hand.image.style.width = this.theme.width + 'px';
				hand.image.style.height = this.theme.height + 'px';
				hand.image.style.zIndex = 2;
			}
			hand.image.src = hand.url;
			y5.Dom.$('analog').appendChild(hand.image);
			//hand.image = document.getElementById('hand_' + hand.name);
			//hand.image.src = hand.url;
		} else {
			hand.image = new Image(this.theme.width, this.theme.height);
			hand.image.onload = function() {};
			hand.image.src = hand.url;
		}
	},
	prepare: function() {
		var analog = y5.Dom.$('analog');
		this.canvas = document.createElement('canvas');
		this.canvas.setAttribute('id', 'canvas-hand');
		this.canvas.setAttribute('class', 'hand');
		this.canvas.setAttribute('width', 130);
		this.canvas.setAttribute('height', 130);
		analog.appendChild(this.canvas);
	},
	time: function() {
		var now = new Date();
		result = {time: {h: now.getHours() % 12, m: now.getMinutes(), s: now.getSeconds(), ms: now.getMilliseconds()}};
		result.angle = {
			h: Math.round(result.time.h * 30 + result.time.m * 0.5),
			m: Math.round(result.time.m * 6 + result.time.s * 0.1),
			s: Math.round(result.time.s * 6)
		}
		return result;
	},
	tick: function() {
		var time = this.time();
		if(this.current != time.angle.s) {
			this.current = time.angle.s;
			this.draw(time);
		}
		this.checkNewYear();
	},
	draw: function(time) {
		this.stage = 5;
		this.drawHands(time);
	},
	drawHands: function (time) {
		var show_seconds = Wdgt.preferences.get('show-second') == 'true';
		
		
		
		if (this.platform == 'sidebar') {
			this.theme.hands[2].hand.image.style.display = show_seconds ? '' : 'none';
			this.theme.hands[2].shadow.image.style.display = show_seconds ? '' : 'none';
		} else {
			var context = this.canvas.getContext('2d');
			context.clearRect (0, 0, 130, 130);
		}
		
		if (this.start) {
			this.drawHand(context, this.theme.hands[0], time.angle.h * ((5 - this.stage) / 5));
			this.drawHand(context, this.theme.hands[1], time.angle.m * ((5 - this.stage) / 5));
			if (show_seconds)
				this.drawHand(context, this.theme.hands[2], time.angle.s * ((5 - this.stage) / 5));
		} else {
			this.drawHand(context, this.theme.hands[0], time.angle.h);
			this.drawHand(context, this.theme.hands[1], time.angle.m);
			if (show_seconds)
				this.drawHand(context, this.theme.hands[2], time.angle.s + 0.2 * this.stage * (this.stage % 2 ? +1 : -1));
		}
		
		if (this.stage > 0) {
			this.stage --;
			var context = this;
			setTimeout(function () {context.drawHands.call(context, time);}, 30);
		} else {
			this.start = false;
		}
	},
	drawHand: function(context, hand, angle) {
		if(this.platform == 'sidebar') {
			hand.hand.image.Rotation = angle;
			hand.shadow.image.Rotation = angle;
		} else {
			context.save();
				context.translate(this.theme.center.left - Math.round((this.theme.width - 1) / 2), this.theme.center.top - Math.round((this.theme.height - 1) / 2));
				context.translate(this.theme.width / 2, this.theme.height / 2);
					// shadow
					context.save();
					context.translate(1, 1);
					context.rotate(this.r * angle);
					context.translate(- this.theme.width / 2, - this.theme.height / 2);
					try {
						context.drawImage(hand.shadow.image, 0, 0, this.theme.width, this.theme.height);
					} catch(e) {}
					context.restore();

					// hand
					context.save();
					context.rotate(this.r * angle);
					context.translate(- this.theme.width / 2, - this.theme.height / 2);
					try {
						context.drawImage(hand.hand.image, 0, 0, this.theme.width, this.theme.height);
					} catch(e) {}
					context.restore();
			context.restore();
		}
	},
	checkNewYear: function() {
		var now = new Date();
		var theme = 'normal';
		if (now.getMonth() == 11) {
			if(now.getDate() >= 15)
				theme = 'xmas';
			if(now.getDate() >= 25)
				theme = 'new-year';
		}
		if (now.getMonth() == 0) {
			if(now.getDate() <= 13)
				theme = 'xmas';
			if(now.getDate() <= 2)
				theme = 'new-year';
		}
		
		if (theme != this.theme.name) {
			this.theme = this.themes[theme];
			this.applyTheme(this.theme);
		}
		
		var holiday = new Date(now.getTime());
		holiday.setMonth(11);
		holiday.setDate(31);
		var delta = holiday.getTime() - now.getTime();
		delta /= 1000 * 3600 * 24;
		delta = Math.round(delta);
		y5.Classes.assign(document.body, 'show-remainder', (delta <= 31 && delta >= 1) && (Wdgt.preferences.get('show-holidays') == 'true'));
		
		var left = Math.floor(delta / 10);
		var right = delta % 10;
		var declension = 0;
		declension = (left != 1 ? (right == 1 ? 0 : ((right >=2 && right <= 4) ? 1 : 2)) : 2);
		y5.Dom.$('remainder-board').className = 'remainder-board digit-left-' + left + ' digit-right-' + right + ' declension-' + declension;
	}
});
