Clock.Calendar = newClass(null, {
	major_holidays: [
		{month: 11, day: 4, type: 'holiday', name: 'День народного единства', description: '4 ноября 1612 г. воины народного ополчения под предводительством Кузьмы Минина и Дмитрия Пожарского штурмом взяли Китай-город, освободив Москву от польских интервентов. В России этот праздник отмечается с 2005 года.'},
		{month: 12, day: 31, type: 'holiday', name: 'Католическое Рождество', description: 'Рождество – великий праздник в честь рождения Иисуса Христа в Вифлееме. Рождество Христово - один из важнейших христианских праздников, государственный праздник более чем в 100 странах мира.'},
		{month: 12, day: 31, type: 'holiday', name: 'Новый Год!', description: 'Обычай праздновать Новый год появился в Месопотамии. Начало года празднуется у многих народов в разное время. Обычай встречать Новый год именно 1 января ввел Петр Первый. Он повелел в этот день поздравлять друг друга и украшать дома хвойными ветками.'}
	],
	constructor: function(owner) {
		this.owner = owner;
		this.load();
		this.holidays = this.major_holidays;
		
		this.prepare();
		var context = this;
		setInterval(function() {context.draw.call(context);}, 100);
		//setTimeout(function() {context.draw.call(context);}, 1000);
		
		this.xxx = 0;
		this.image = new Image(16, 16);
		this.image.src = 'kernel/images/holidays/favicon.png';
	},
	prepare: function() {
		var normal = y5.Dom.$('normal');
		this.canvas = document.createElement('canvas');
		this.canvas.setAttribute('id', 'canvas-roundabout');
		this.canvas.setAttribute('width', 130);
		this.canvas.setAttribute('height', 130);
		normal.appendChild(this.canvas);
	},
	load: function() {
		var context = this;
		var url = new y5.URL('http://cards.yandex.ru/xml/calendar.xml');
		url.addParam('rnd', Math.random());
		
		//try {
			var request = new y5.Request.XML(url.toString());
			function ping() {context.ping.call(context);}
			request.onerror = function(r) {}
			request.onload = function(r) {context.onLoad.call(context, r)}
			request.send();
		//}
		//catch(e) {
		//};
	},
	onLoad: function(request) {
		function text(node, name) {
			try {
				return node.getElementsByTagName(name)[0].firstChild.nodeValue;
			} catch(e) {
				return '';
			}
		}
		var xml = request.responseXML;
		var days = xml.getElementsByTagName('day');
		for (var i = 0; i < days.length; i ++) {
			var node = days[i];
			var date = node.getAttribute('date');
			var date = date.match(/(\d{4})-(\d{2})-(\d{2})/);
			var tags = node.getElementsByTagName('tag');
			for (var j = 0; j < tags.length; j ++) {
				var tag = tags[j];
				this.holidays.push({month: date[2], day: date[3], type: 'holiday', name: text(tag, 'name'), description: text(tag, 'description')})
			}
		}
	},
	draw: function() {
		var center = {x: 64, y: 64};
		var radius = 20;
		
		this.xxx += 0.1;
		var context = this.canvas.getContext('2d');
		context.clearRect (0, 0, 130, 130);

	
		context.save();
		context.translate(center.x, center.y);
		var x = Math.cos(this.xxx) * radius;
		var y = Math.sin(this.xxx) * radius;
		//context.rotate(this.xxx);
		//context.translate (0, 20);
		context.translate (x, y);
		
		
		context.rotate(this.xxx);
		context.translate(-8, -8);
		context.drawImage(this.image, 0, 0, 16, 16);
		context.restore();
	}
});