Clock.Digital = newClass(null, {
	theme: {
		background: 'kernel/images/clock/digital/background.png'
	},
	constructor: function(owner) {
		this.owner = owner;
		new y5.Observer('tick', this.tick, this, true, this);
	},
	tick: function(time) {
		if(this.current != time.s) {
			this.current = time.s;
			
			y5.Dom.$('digital-hour-one').className = 'figure figure-' + Math.floor(time.h / 10);
			y5.Dom.$('digital-hour-two').className = 'figure figure-' + (time.h % 10);
			y5.Dom.$('digital-minute-one').className = 'figure figure-' + Math.floor(time.m / 10);
			y5.Dom.$('digital-minute-two').className = 'figure figure-' + (time.m % 10);
			
			y5.Classes.assign(y5.Dom.$('digital-hour-one').parentNode, 'flash', time.s % 2 == 0);
	
			y5.Dom.$('digital-date').innerHTML = y5.Dates.toFormat(time.date, '%e %B');
			var weekdays = ['вс', 'пн', 'вт', 'ср', 'чт', 'пт', 'сб'];
			y5.Dom.$('digital-weekday').innerHTML = weekdays[time.date.getDay()];
		}
	}
});