Clock.Roundabout = newClass(null, {
	major_holidays: [

		{month: 4, date: 12, icon: '12_Apr.png', name: '', description: ''},
		{month: 12, date: 12, icon: '12_Dec.png', name: '', description: ''},
		{month: 6, date: 12, icon: '12_Jun.png', name: '', description: ''},
		{month: 2, date: 14, icon: '14_Feb.png', name: '', description: ''},
		{month: 4, date: 1, icon: '1_Apr.png', name: '', description: ''},
		{month: 1, date: 1, icon: '1_Jan.png', name: '', description: ''},
		{month: 5, date: 1, icon: '1_May.png', name: '', description: ''},
		{month: 9, date: 1, icon: '1_Sep.png', name: '', description: ''},
		{month: 2, date: 23, icon: '23_Sep.png', name: '', description: ''},
		{month: 2, date: 2, icon: '2_Feb.png', name: '', description: ''},
		{month: 10, date: 31, icon: '31_Oct.png', name: '', description: ''},
		{month: 11, date: 3, icon: '3_Nov.png', name: '', description: ''},
		{month: 3, date: 8, icon: '8_Mar.png', name: '', description: ''},
		{month: 5, date: 9, icon: '9_May.png', name: '', description: ''}
	],
	r: 2*Math.PI/360,
	constructor: function(owner) {
		this.owner = owner;
		this.platform = Wdgt.platform.name;
		this.holidays = this.major_holidays;
		this.step = 25;
		
		
		this.prepare();
		var context = this;
		setInterval(function() {context.draw.call(context);}, 10);
		//setTimeout(function() {context.draw.call(context);}, 1000);
		
		this.xxx = 0;
		this.image = new Image(16, 16);
		this.image.src = 'kernel/images/holidays/1_Jan.png';
	},
	prepare: function() {
		var roundabout = y5.Dom.$('roundabout');
		this.canvas = document.createElement('canvas');
		this.canvas.setAttribute('id', 'canvas-roundabout');
		this.canvas.setAttribute('width', 130);
		this.canvas.setAttribute('height', 130);
		roundabout.insertBefore(this.canvas, roundabout.childNodes[2]);

		function rule(a, b) {
			if (a.month == b.month)
				if(a.date < b.date) return -1; else return 1;
			if(a.month < b.month) return -1; else return 1;
		}
		
		this.holidays.sort(rule);
		
		for (var i = 0; i < this.holidays.length; i ++)
			this.initIcon(this.holidays[i]);
	},
	initIcon: function(holiday) {
		if (this.platform == 'sidebar') {
			/*
			var id = 'hand-' + name + '-' + type;
			if (y5.Dom.$(id))
				hand.image = y5.Dom.$(id);
			if (!hand.image) {
				hand.image = document.createElement('g:image');
				hand.image.id = id;
				hand.image.style.position = 'absolute';
				hand.image.style.left = (50 + (type == 'hand' ? 0 : 1 )) + 'px';;
				hand.image.style.top = (type == 'hand' ? 0 : 1 ) + 'px';
				hand.image.style.width = this.theme.width + 'px';
				hand.image.style.height = this.theme.height + 'px';
				hand.image.style.zIndex = 2;
			}
			hand.image.src = hand.url;
			y5.Dom.$('normal').appendChild(hand.image);
			//hand.image = document.getElementById('hand_' + hand.name);
			//hand.image.src = hand.url;
			*/
		} else {
			holiday.image = new Image(16, 16);
			holiday.image.onload = function() {};
			holiday.image.src = 'kernel/images/holidays/' + holiday.icon;
		}
	},
	position: function() {
		position = -1;
		var now = new Date();
		for (var i = 0; i < this.holidays.length; i++) {
			var holiday = this.holidays[i];
			if (holiday.month >= now.getMonth() && holiday.date >= now.getDate()) {
				position = i;
				break;
			}
		}
		
		var prev = this.holidays[position];
		var next = this.holidays[(position + 1) % this.holidays.length];
		
		var date_prev = new Date(), date_next = new Date();
		date_prev.setMonth(prev.month - 1);
		date_prev.setDate(prev.date);
		date_next.setMonth(next.month - 1);
		date_next.setDate(next.date);
		if(date_next.getTime() - date_prev.getTime() < 0)
			date_next.setYear(date_next.getYear() + 1);
		var delta = (date_next.getTime() - date_prev.getTime()) / (1000 * 3600 * 24);
		return {position: position, delta: delta}
	},
	draw: function() {
		var context = this.canvas.getContext('2d');
		context.clearRect (0, 0, 130, 130);
		var position = this.position();
		var length = this.holidays.length;
		this.drawIcon(context, this.holidays[position.position], 0, position.delta);
		for(var i = 0; i < 4; i ++) {
			this.drawIcon(context, this.holidays[(position.position + i) % length], + i, position.delta);
			this.drawIcon(context, this.holidays[(position.position + length - i) % length], - i, position.delta);
		}
		/*
		context.save();
		context.translate(center.x, center.y);
		var x = Math.cos(this.r * this.xxx) * radius;
		var y = Math.sin(this.r * this.xxx) * radius;
		//context.rotate(this.xxx);
		//context.translate (0, 20);
		context.translate (x, y);
		
		
		context.rotate(this.r * (this.xxx - 90));
		context.translate(-8, -8);
		context.drawImage(this.image, 0, 0, 16, 16);
		context.restore();
		*/
	},
	drawIcon: function(context, holiday, position, delta) {
		var center = {x: 64, y: 64};
		var radius = 41;
		var angle = 90 + delta + position * this.step;
		
		context.save();
		context.translate(center.x, center.y);
		var x = Math.cos(this.r * angle) * radius;
		var y = Math.sin(this.r * angle) * radius;
		context.translate (x, y);
		context.rotate(this.r * (angle - 90));
		context.translate(-8, -8);
		context.drawImage(holiday.image, 0, 0, 16, 16);
		context.restore();		
	}
/*
	load: function() {
		var context = this;
		var url = new y5.URL('http://cards.yandex.ru/xml/calendar.xml');
		url.addParam('rnd', Math.random());
		
		//try {
			var request = new y5.Request.XML(url.toString());
			function ping() {context.ping.call(context);}
			request.onerror = function(r) {}
			request.onload = function(r) {context.onLoad.call(context, r)}
			request.send();
		//}
		//catch(e) {
		//};
	},
	onLoad: function(request) {
		function text(node, name) {
			try {
				return node.getElementsByTagName(name)[0].firstChild.nodeValue;
			} catch(e) {
				return '';
			}
		}
		var xml = request.responseXML;
		var days = xml.getElementsByTagName('date');
		for (var i = 0; i < days.length; i ++) {
			var node = days[i];
			var date = node.getAttribute('date');
			var date = date.match(/(\d{4})-(\d{2})-(\d{2})/);
			var tags = node.getElementsByTagName('tag');
			for (var j = 0; j < tags.length; j ++) {
				var tag = tags[j];
				this.holidays.push({month: date[2], date: date[3], type: 'holiday', name: text(tag, 'name'), description: text(tag, 'description')})
			}
		}
	},
*/	
});