Wdgt.Focus = newClass(null, {
	constructor: function(owner, host) {
		this.owner = owner;
		this.host = host;
		
		this.timer_focus = 0;
		this.timer_blur = 0;
		this.timer_freeze = 0;
		this.state = '';
		this.count = {'+': 0, '-': 0};
		this.last = '';
		this.lock = false;		
	},
	
	get: function() {
		return this.state == 'focus';
	},	
	subscribe: function(element, all) {
		y5.Events.observe('focus', this.onfocus, element, true, this);
		y5.Events.observe('blur', this.onblur, element, true, this);
		
		if(all) {
			var nodes = y5.Dom.getDescendants(element, '*', '*', 512);
			for(var i = 0; i < nodes.length; i++) {
				y5.Events.observe('focus', this.onfocus, nodes[i], true, this);
				y5.Events.observe('blur', this.onblur, nodes[i], true, this);
			}
		}
	},
	
	onfocus: function() {
		this.last = '+';
		this.count['+'] ++;
		clearTimeout(this.timer_blur);
		clearTimeout(this.timer_focus);
		var context = this;
		function contextAction() {context.action.call(context);}
		this.timer_focus = setTimeout(contextAction, 100);
	},
	
	onblur: function() {
		this.last = '-';
		this.count['-'] ++;
		clearTimeout(this.timer_blur);
		clearTimeout(this.timer_focus);
		var context = this;
		function contextAction() {context.action.call(context);}
		this.timer_blur = setTimeout(contextAction, 400);
	},

	action: function() {
		if(this.lock)
			return;
		if((this.count['-'] < this.count['+']) || (this.last == '+'))
			this.fireFocus();
		else
			this.fireBlur();
		this.count = {'+': 0, '-': 0};
	},
	freeze: function() {
		this.lock = true;
		clearTimeout(this.timer_blur);
		clearTimeout(this.timer_focus);
		clearTimeout(this.timer_freeze);
		var context = this;
		function freezeContext() {
			context.lock = false;
			context.count = {'+': 0, '-': 0};
			clearTimeout(context.timer_blur);
			clearTimeout(context.timer_focus);
		}
		this.timer_freeze = setTimeout(freezeContext, 1700);
	},	
	fireFocus: function() {
		if(this.state == 'focus')
			return;
		this.state = 'focus';
		y5.Notify('focus-set', this.host);
		//y5.Dom.$('search-line-request').value += 'f';
	},
	
	fireBlur: function() {
		if(this.state == 'blur')
			return;
		this.state = 'blur';
		y5.Notify('focus-kill', this.host);
		//y5.Dom.$('search-line-request').value += 'b';
	}	
});

/*
Wdgt.Focus = new function() {
	var PARENT = Wdgt;	
	var THIS = this;
	var timer_focus = 0;
	var timer_blur = 0;
	var timer_freeze = 0;
	var state = '';
	var count = {'+': 0, '-': 0};
	var last = '';
	var lock = false;
	this.get = function() {
		return state;
	}
	
	this.subscribe = function(element, all) {
		y5.Events.observe('focus', onfocus, element, true);
		y5.Events.observe('blur', onblur, element, true);
		
		if(all) {
			var nodes = y5.Dom.getDescendants(element, '*', '*', 512);
			for(var i = 0; i < nodes.length; i++) {
				y5.Events.observe('focus', onfocus, nodes[i], true);
				y5.Events.observe('blur', onblur, nodes[i], true);
			}
		}
	}
	
	function onfocus() {
		last = '+';
		count['+'] ++;
		clearTimeout(timer_blur);
		clearTimeout(timer_focus);
		timer_focus = setTimeout(action, 100);
	}
	function onblur() {
		last = '-';
		count['-'] ++;
		clearTimeout(timer_blur);
		clearTimeout(timer_focus);
		timer_blur = setTimeout(action, 100);
	}	

	
	function action() {
		if(lock)
			return;
		if((count['-'] < count['+']) || (last == '+'))
			fireFocus();
		else
			fireBlur();
		count = {'+': 0, '-': 0};
	}
	

	this.freeze = function() {
		lock = true;
		clearTimeout(timer_blur);
		clearTimeout(timer_focus);
		clearTimeout(timer_freeze);
		timer_freeze = setTimeout(function(){lock = false; count = {'+': 0, '-': 0};clearTimeout(timer_blur);clearTimeout(timer_focus);}, 1700);
	}
	
	function fireFocus() {
		if(state == 'focus')
			return;
		state = 'focus';
		//y5.Dom.$('search-line-request').value += 'f';
		if(THIS.onfocus)
			THIS.onfocus();
	}
	
	function fireBlur() {
		if(state == 'blur')
			return;
		state = 'blur';
		//y5.Dom.$('search-line-request').value += 'b';
		if(THIS.onblur)
			THIS.onblur();
	}
}
*/