Wdgt.Menu = newClass(null, {
	constructor: function(menu, behaviour) {
		this.menu = menu;
		this.behaviour = behaviour;
		this.border = null;
		this.root = null;
		this.shortcuts = null;
		
		if(this.menu)
			this.create();
		new y5.Observer('menu-hide', this.hide, Wdgt.Menu, true, this);
		new y5.Observer('force-send-change-state', this.changeState, Wdgt.Menu, true, this);
		
		if(Wdgt.platform.name != 'sidebar')
			y5.Events.observe('blur', this.hide, document.body, true, this);
	},
	
	create: function(menu) {
		if(this.border)
			y5.Dom.removeNode(this.border);
		
		this.border = document.createElement('div');
		this.border.className = 'menu ' + this.behaviour.name;
		this.border.style.display = 'none';
		
		var frame = document.createElement('div');
		frame.className = 'frame';
		
		
		
		var html = '<div class="left"></div><div class="center"><div></div></div><div class="right"></div>';
		var top = document.createElement('div');
		top.className = 'top';
		top.innerHTML = html;
		var bottom = document.createElement('div');
		bottom.className = 'bottom';
		bottom.innerHTML = html;
		var middle = document.createElement('div');
		middle.className = 'middle';
		
		middle.appendChild(frame);
		
		this.border.appendChild(top);
		this.border.appendChild(middle);
		this.border.appendChild(bottom);

		if(this.behaviour.max_height) {
			if(document.compatMode != 'BackCompat')
				middle.style.maxHeight = (this.behaviour.max_height) + 'px';
			//middle.style.height = (this.behaviour.max_height) + 'px';
			middle.style.overflowY = 'auto';
			middle.style.overflowX = 'hidden';
			//if(Wdgt.platform.name == 'opera')
				middle.style.overflow = 'auto';
		}
		
		this.behaviour.container.appendChild(this.border);
		
		if(menu)
			this.menu = menu;
		
		this.root = this.create_ul(this.menu, frame);
		this.root.style.display = '';
		if(Wdgt.platform.name == 'sidebar' && this.behaviour.owner.focus)
			this.behaviour.owner.focus.subscribe(this.border, true); // жусть
	},
	
	create_li: function(menu) {
		var li = document.createElement('li');
		if(!menu.id)
			menu.id = Math.round(Math.random() * 10000000).toString()
		li.setAttribute('menu', menu.id);

		var item = document.createElement('div');
		item.className = 'item';
		
		var icon = document.createElement('div');
		icon.className = 'icon';
		if(menu.icon != '')
			icon.style.backgroundImage = 'url(kernel/images/icons/services/' + menu.icon + ')';
		var title = document.createElement('div');
		title.className = 'title'
		title.innerHTML = menu.title;
		var clear = document.createElement('div');
		clear.className = 'clear';
		
		if(!menu.disable) {
			y5.Events.observe('mouseover', this.onItemMouseOver, item, true, this);
			//y5.Events.observe('mouseout', this.onItemMouseOut, item, true, this);
		}
		if(menu.className)
			y5.Classes.add(item, menu.className);
		//* item.className += (menu.className ? ' ' + menu.className : '');
		//* item.setAttribute('menu-id', menu.id);
		
		item.appendChild(icon);
		item.appendChild(title);
		item.appendChild(clear);
		
		y5.Classes.assign(li, 'disable', menu.disable);
		y5.Classes.assign(li, 'hide-after-expand', menu.hide_after_expand);
		/* *
		if(menu.disable)
			li.className += ' disable';
		if(menu.hide_after_expand)
			li.className += ' hide-after-expand';
		*/
		li.appendChild(item);
		if(menu.menu) {
			title.innerHTML += '<img src="kernel/images/icons/arrow-right.png" width="5" height="5" class="arrow-down"/>';
			title.innerHTML += '<img src="kernel/images/icons/arrow-down.png" width="5" height="5" class="arrow-right"/>';
			/*
			var arrow = document.createElement('div');
			arrow.innerHTML = '<div style="height:5px;width:5px;"></div>';
			arrow.className = 'arrow';
			title.appendChild(arrow);
			*/
			this.create_ul(menu.menu, li);
			
			
			y5.Classes.add(item, 'group folder'); /* folder -> group*/
			y5.Classes.add(li, 'group-close'); /* folder -> group*/
			//* item.className += ' folder';
			//* li.className += ' group-close';
		} else {
			/*
			new function(item, menu) {
				y5.Events.observe('mousedown', function (e) { click(e, menu, true);}, element, true);
			}
			*/
//			new createAction(item, menu);
		}
		
		y5.Events.observe('mousedown', this.onItemMouseDown, item, true, this);
		
		return li;
	},
	
	create_ul: function(menu, parent) {
		var ul = document.createElement('ul');
		for(var i = 0; i < menu.length; i++) {
			ul.appendChild(this.create_li(menu[i]));
			menu[i].parent = menu;
		}
		parent.appendChild(ul);
		return ul;
	},

	
	hideAllMenu: function(force) {
		y5.Notify('menu-hide', Wdgt.Menu);
		/*
		if(!force && (window.showHideMenuTimer != 0))
			return;
		if(Search.activeMenu)
			Search.activeMenu.hide();
		Search.activeMenu = null;
		*/
	},
	
	isVisible: function() {
		return !!(this.border && (this.border.style.display != 'none'));
	},
	
	visibility: function(show) {
		if((typeof(show) != 'undefined') && (this.isVisible() == show))
			return;
		show = (typeof(show) == 'undefined' ? !this.isVisible() : show);
		if(show) {
			/*
			clearTimeout(window.showHideMenuTimer);
			window.showHideMenuTimer = setTimeout(function(){window.showHideMenuTimer = 0;}, 200);
			*/
			this.hideAllMenu(true);
			// * Search.activeMenu = THIS;
		} else {
			//if(Search.activeMenu == THIS)
			//	Search.activeMenu = null;
		}
		//document.getElementById('search-button').innerHTML += (show ? '(+)' : '(-)');
		//if(!show)
		//	debugger;
		
		//this.clearSelection();
		
		this.border.style.display = (show ? '' : 'none');
		this.shortcut(show);
		//* updateMode();
		if(show) {
			var context = this;
			function assign() {
				context.outsideClickObserver = y5.Events.observe('mousedown', context.onOutsideClick, document.body, true, context);
			}
			setTimeout(assign, 100);
			//this.outsideClickObserver = y5.Events.observe('click', this.onOutsideClick, document.body, true, this);
		}
		else
			if(this.outsideClickObserver) {
				this.outsideClickObserver.remove();
				delete this.outsideClickObserver;
				this.outsideClickObserver = null;
			}
		this.changeState();
	},
	changeState: function() {
		if(this.behaviour.owner && this.border) {
			var visible = this.isVisible();
			y5.Notify('menu-change-state', this.behaviour.owner, {menu: this, visible: visible, left: this.border.offsetLeft, top: this.border.offsetTop, height: (visible ? this.border.clientHeight : 0)});
		}
	},
	show: function() {
		this.visibility(true);
	},
	
	hide: function() {
		this.visibility(false);
	},
	
	onMenuHide: function() {
		this.hide();
	},
	selectFirstItem: function() {
		var li = y5.Dom.getDescendant(this.root, 'li', '*');
		while(y5.Classes.test(li, 'disable'))
			li = li.nextSibling;
		var item = y5.Dom.getDescendant(li, 'div', 'item');
		this.onItemMouseOver({target: item});
	},	
	clearSelection: function() {
		var descendants = y5.Dom.getDescendants(this.border, 'div', 'item');
		for(var i = 0; i < descendants.length; i++)
			y5.Classes.remove(descendants[i], 'hover');
	},
	closeGroups: function() {
		if(!this.border)
			return;
		var descendants = y5.Dom.getDescendants(this.border, 'li', 'group-open');
		for(var i = 0; i < descendants.length; i++)
			y5.Classes.replace(descendants[i], 'group-open', 'group-close');
	},
	getById: function(id, menu) {
		if(typeof menu == 'undefined')
			menu = this.menu;
		for(var i = 0; i < menu.length; i++) {
			var m = menu[i];
			if(!m)
				continue;
			if(m.id == id)
				return m;
			if(m.menu) {
				var r = this.getById(id, m.menu);
				if(r)
					return r;
			}
		}
		return null;
	},
	getActive: function() {
		try {
			var item = y5.Dom.getDescendant(this.border, '*', 'hover');
			if(!item)
				return null;
			var li = y5.Dom.getAncestor(item, 'li', '*');
			var id = li.getAttribute('menu');
			var menu = this.getById(id);
			return {li: li, item: item, menu: menu};
		} catch(e) {
			return null;
		}
	},
	// события на элементе меню
	onItemMouseOver: function(e) {
		var node = e.target;
		var item = y5.Dom.getAncestor(node, 'div', 'item') || node;
		var li = y5.Dom.getAncestor(item, 'li', '*');
		if(y5.Classes.test(item, 'hover'))
			return;

		this.clearSelection();
		y5.Classes.add(item, 'hover');
		y5.Notify('item-hover', this);
		//this.hover(li);
	},
	onItemMouseDown: function(e) {
		var title = e.target;
		var click_li = y5.Dom.getParentByTagName(title, 'li');
		var click_ul = y5.Dom.getElementByTagName('ul', click_li);
		var show = y5.Dom.testElement(click_li, '*', 'group-close');
		
		var id = click_li.getAttribute('menu');
		var item = this.getById(id);
		if(item.action) {
			item.action(item);
			this.hide();
		}

		y5.Notify('item-click', this);
				
		if(typeof item.menu != 'undefined') {
			if(y5.Classes.test(click_li, 'hide-after-expand')) {
				var focus = null;
				while(click_ul.childNodes.length != 0) {
					node = click_ul.childNodes[0];
					if(node && node.tagName && (node.tagName == 'LI')) {
						node.parentNode.removeChild(node);
						click_li.parentNode.insertBefore(node, click_li);
						if(!focus)
							focus = node;
					} else {
						node.parentNode.removeChild(node);
					}
				}
				
				var item = focus.firstChild;
				this.clearSelection();
				y5.Classes.add(item, 'hover');
				
				click_li.style.display = 'none';
				y5.Classes.add(click_li, 'disable');
				//click_li.parentNode.removeChild(click_li);

				var menu = this.getById(click_li.getAttribute('menu'));
				var parent = menu.parent;
				menu = menu.menu;
				var i = 0;
				for(i = 0; i < parent.length; i++)
					if(parent[i] == menu)
						break;
				for(var j = 0; j < menu.length; j ++)
					parent.splice(i + j, 0, menu[j]);
				parent.splice(i - 1, 1);


				y5.Notify('item-hover', this);
				if (e.key)
					y5.Notify('item-key', this);
			} else {
				y5.Classes.toggle(click_li, 'group-close');
				y5.Classes.toggle(click_li, 'group-open');
			}
		}
		
		this.changeState();
		//Wdgt.Focus.freeze();
		//updateMode();	
	},
	//
	onOutsideClick: function(e) {
		if(y5.Dom.getAncestor(e.target, 'div', 'menu') != null)
			return;
		if(this.isVisible())
			this.hide();
	},
	// shortcuts
	shortcut: function(enable) {
		if(enable) {
			var options_left_right = {
				checkTarget: false,
				preventDefault: false,
				context: this
			};
			var options = {
				checkTarget: false,
				preventDefault: true,
				context: this
			};
			var i = 0;
			if(this.shortcuts == null) {
				this.shortcuts = [];
				this.shortcuts[i++] = y5.ShortCut.down([{key: y5.ShortCut.LEFT_ARROW}], this.onKeyLeft, document, options_left_right);
				this.shortcuts[i++] = y5.ShortCut.down([{key: y5.ShortCut.RIGHT_ARROW}], this.onKeyRight, document, options_left_right);
				
				this.shortcuts[i++] = y5.ShortCut.press([{key: y5.ShortCut.UP_ARROW}], this.onKeyUp, document, options);
				this.shortcuts[i++] = y5.ShortCut.press([{key: y5.ShortCut.DOWN_ARROW}], this.onKeyDown, document, options);
				
				if(Wdgt.platform.name == 'dashboard') {
					this.shortcuts[i++] = y5.ShortCut.down([{key: y5.ShortCut.DOWN_ARROW}], this.onKeyDown, document, options);
					this.shortcuts[i++] = y5.ShortCut.down([{key: y5.ShortCut.UP_ARROW}], this.onKeyUp, document, options);
				}
				
				this.shortcuts[i++] = y5.ShortCut.down([{key: y5.ShortCut.ENTER}], this.onKeyEnter, document, options);
				this.shortcuts[i++] = y5.ShortCut.down([{key: y5.ShortCut.ESC}], function() {var context = this; setTimeout(function() {context.hide.call(context);}, 0);}, document, options);
			}
		} else {
			if(this.shortcuts) {
				for(var i = 0; i < this.shortcuts.length; i++)
					y5.ShortCut.remove(this.shortcuts[i]);
				this.shortcuts = null;
			}
		}
	},
	
	onKeyUp: function(e) {this.onKeyUpDown('up', e);},
	onKeyDown: function(e) {this.onKeyUpDown('down', e);},
	onKeyLeft: function(e) {this.onKeyLeftRightEnter('left', e);},
	onKeyRight: function(e) {this.onKeyLeftRightEnter('right', e);},
	onKeyEnter: function(e) {this.onKeyLeftRightEnter('enter', e);},
	
	onKeyUpDown: function(direction) {
		function getNext(li, x) {
			if(!li)
				return null;
			var next = null;
			next = y5.Dom.getDescendant(li, 'ul', '*');
			
			if(!x && next && !y5.Dom.testElement(li, '*', 'group-close')) {
				next = y5.Dom.getDescendant(next, 'li', '*');
				if(next)
					return next;
			}
			next = y5.Dom.getNext(li, 'li', '*');
			if(next)
				return next;
			next = y5.Dom.getAncestor(li, 'li', '*');
			next = getNext(next, true);
			return next;
		}
		
		function getPrev(li) {
			if(!li)
				return null;
			var next = null;
			next = y5.Dom.getPrev(li, 'li', '*');
			if(next) {
				var li = next, ul = null;
				while(li) {
					next = li;
					ul = y5.Dom.getDescendant(next, 'ul', '*');
					if(ul && !y5.Dom.testElement(li, '*', 'group-close'))
						li = ul.lastChild;
					else
						break;
				}
				return next;
			}
			next = y5.Dom.getAncestor(li, 'li', '*');
			return next;
		}

		// main code
		var li = null;
		var item = y5.Dom.getDescendant(this.border, '*', 'hover');
		if(item == null) {
			// переписать!
			var descendants = y5.Dom.getDescendants(this.border, 'li', '');
			for(var i = 0; i < descendants.length; i++)
				if(!y5.Classes.test(descendants[i], 'disable')) {
					li = descendants[i];
					item = y5.Dom.getDescendant(li, '*', 'item');
					break;
				}
			y5.Classes.add(item, 'hover');
		} else {
			var next_li = item.parentNode;
			while(true)
			{
				if(direction == 'down')
					next_li = getNext(next_li);
				else
					next_li = getPrev(next_li);
				
				if(!next_li)
					break;
					
				if(!y5.Classes.test(next_li, 'disable'))
					break;
			}
			
			if(next_li) {
				var next_item = y5.Dom.getDescendant(next_li, '*', 'item');
				y5.Classes.remove(item, 'hover');
				y5.Classes.add(next_item, 'hover');
				item = next_item;
				li = next_li;
			}
		}
		
		y5.Notify('item-key', this);
		if(li)
			this.scrollTo(li);
	},
	
	onKeyLeftRightEnter: function(direction, e) {
		function boom(target) {
			this.onItemMouseDown({target: target, key: true});
		}
		var item = y5.Dom.getDescendant(this.border, '*', 'hover');
		if(item) {
			if(direction == 'enter') {
				boom.call(this, item);
			} else {
				var ul = y5.Dom.getNext(item, 'ul', '*');
				if(ul) {
					var li = y5.Dom.getAncestor(item, 'li', '*');
					var isClose = y5.Dom.testElement(li, '*', 'group-close');
					if(
						((direction == 'right') && (isClose)) ||
						((direction == 'left') && (!isClose))
					) {
						boom.call(this, item);
						e.preventDefault();
						e.stopPropagation();
					}
				}
			}
		}		
	},
	
	scrollTo: function(li) {
		var container = this.border.childNodes[1];
		var offset = container.scrollTop;
		var container_height = container.clientHeight;
		var container_offset = container.scrollTop;
		var content_height = container.scrollHeight;
		var li_offset = li.offsetTop/* - 3*/;
		
		
		if(Wdgt.platform.name != 'sidebar')
			li_offset -= 3;
		
		var li_height = li.clientHeight;
		if(li_offset + li_height > container_offset + container_height) {
			container.scrollTop = li_offset + li_height - container_height;
			return;
		}

		if(li_offset < container_offset) {
			container.scrollTop = li_offset;
			return;
		}
	}
	
});