Wdgt.Mode = newClass(null, {
	constructor: function() {
		this.settings = {};
	},
	mode: function(name, settings) {
		settings.current = settings.current || {};
		this.settings[name] = settings;
	},
	set: function(space, value, force) {
		var settings = this.settings[space];
		if (!settings)
			throw "Undefined space.";
		
		if ((value != settings.current) || !!force) {
			settings.current = value;

			if (settings.store)
				Wdgt.preferences.set(settings.store, value);

			if (settings.transition) {
				var transition = settings.transition[value] || settings.transition['default'] || 'ToFront';
				Wdgt.view.prepareForTransition(transition);
			}
			
			document.body.className = y5.Strings.normalizeSpace(document.body.className.replace(new RegExp('' + space + '-(\\S+)', 'g'), ''));
			y5.Classes.add(document.body, space + '-' + value);
			
			if (settings.event) {
				settings.event.call(this, space, value);
			}
			
			if (settings.transition)
				Wdgt.view.performTransition();
		}	
	},
	get: function(space) {
		return this.settings[space].current;
	},
	reset: function(space) {
		this.set(space, this.settings[space].current, true);
	}
});
