WdgtPreferences = newClass(null, {
	constructor: function(owner) {
		this.owner = owner;
		this.ready = false;
		this.cache = {};
		this.modes = {}; /* (instance, collection, all, instance-collection) */
	},
	
	init: function() {
		if(this.ready)
			return;

		if (Wdgt.platform.name == 'sidebar') {
			this.shell = new ActiveXObject('WScript.Shell');
			this.shell.RegWrite(this.registerPath(), 0);
		}
		
		this.ready = true;
	},

	registerPath: function() {
		return 'HKEY_CURRENT_USER\\Software\\Yandex\\' + this.owner.getInfo().name + '\\';
	},
	mode: function(name, value, def) {
		if (typeof value == 'undefined') {
			if (typeof this.modes[name] == 'undefined')
				return 'instance';
			return this.modes[name];
		} else {
			this.modes[name] = value;
		}
		
		if (typeof def != 'undefined')
			if (this.get(name, null) == null)
				this.set(name, def);
	},
	set: function(name, value, time) {
		this.init();
		this.cache[name] = value;
		
		var mode = this.mode(name);
		switch(Wdgt.platform.name) {
			case 'dashboard':
				switch(mode) {
					case 'instance':
						return widget.setPreferenceForKey(value, widget.identifier + '-' + name);
					case 'instance-collection':
						widget.setPreferenceForKey(value, name + '-per-collection');
						return widget.setPreferenceForKey(value, widget.identifier + '-' + name);
					case 'collection':
					case 'all':
						return widget.setPreferenceForKey(value, name);
				}
			break;
			case 'sidebar':
				switch(mode) {
					case 'instance':
						return System.Gadget.Settings.writeString(name, value);
					case 'instance-collection':
						this.shell.RegWrite(this.registerPath() + name + '-per-collection', value);
						return System.Gadget.Settings.writeString(name, value);
					case 'collection':
					case 'all':
						return this.shell.RegWrite(this.registerPath() + name, value);
				}
			break;
			case 'opera':
				return widget.setPreferenceForKey(value, name);
			break;
		}
	},
	get: function(name, def) {
		this.init();
				
		if((typeof this.cache[name] != 'undefined') && (this.cache[name] != null))
			return this.cache[name];
		
		if(typeof def == 'undefined')
			def = '';
			
		var mode = this.mode(name);
		switch(Wdgt.platform.name) {
			case 'dashboard':
				switch(mode) {
					case 'instance':
						return widget.preferenceForKey(widget.identifier + '-' + name) || def;
					case 'instance-collection':
						return widget.preferenceForKey(widget.identifier + '-' + name) || widget.preferenceForKey(name + '-per-collection') || def;
					case 'collection':
					case 'all':
						return widget.preferenceForKey(name) || def;
				}
			break;
			case 'sidebar':
				switch(mode) {
					case 'instance':
						return System.Gadget.Settings.readString(name) || def;
					case 'instance-collection':
						var value = System.Gadget.Settings.readString(name);
						if (!value) {
							try {
								value = this.shell.RegRead(this.registerPath() + name + '-per-collection');
							}
							catch(e) {}
						}
						return value || def;
					case 'collection':
					case 'all':
						try {
							return this.shell.RegRead(this.registerPath() + name);
						}
						catch(e) {
							return def;
						}
				}
			break;
			case 'opera':
				return widget.preferenceForKey(name) || def;
			break;
		}
	},
	clear: function(name) {
		this.set(name, '');
	}
});