WdgtView = newClass(null, {
	constructor: function(owner) {
		this.owner = owner;
		this.background = null;
	},
	
	setBackground: function(image, width, height, left, top) {
		if(image instanceof Array) {
			var backgrounds = image;
			this.background = backgrounds;
			switch(this.owner.platform.name) {
				case 'opera': 
				case 'dashboard':
				{
					var background = y5.Dom.$('background');
					if(!background) {
						background = document.createElement('div');
						background.setAttribute('id', 'background');
						document.body.insertBefore(background, document.body.firstChild);
					}
					
					background.innerHTML = '';

					if(1 || this.owner.platform.name == 'opera' && this.owner.platform.os == 'linux') {
						var layer = document.createElement('div');
						layer.className = 'opera-linux-background';
						background.appendChild(layer);
					}
					
					for(var i = 0; i < backgrounds.length; i ++) {
						var item = backgrounds[i];
						var layer = document.createElement('div');
						layer.style.background = 'transparent url(' + item.url + ') ' + item.left + 'px ' + item.top + 'px no-repeat';
						background.appendChild(layer);
					}
				}
				break;
				
				case 'sidebar':
				{
					var background = document.getElementById('background');			
					background.removeObjects();
					for(var i = 0; i < backgrounds.length; i ++) {
						var item = backgrounds[i];
						if(item.text) {
							var text = background.addTextObject(item.text, 'Segoe UI' , 12, "White", item.left, item.top);
							text.addShadow("Color(255, 0, 0, 0)", 10, 100, 0, 0);
						} else
							background.addImageObject(item.url, item.left, item.top);
					}
				}
				break;
			}
			
			
			return;
		}
	
	
		if(typeof left == 'undefined')
			left = 0;
		if(typeof top == 'undefined')
			top = 0;
		switch(this.owner.platform.name) {
			case 'sidebar':
				{
					var b = document.getElementById('background');					
					b.removeObjects();
					b.addImageObject(image, left, top);

										
					/*
					b.src = 'url(' + image + ')';
			//		b.removeObjects();
			//		b.addImageObject(image, 0, 0);
				//	b.src = 'url(' + image + ')';
				//	b.style.height = height + 'px';
				//	b.style.width = width + 'px';
				//	b.style.backgroundRepeat = 'no-repeat';
					*/

					this.background = {image: image, left: left, top: top, height: height, width: width};
				}
			break;
			case 'dashboard':
				{
					document.body.style.background = 'url(' + image + ') 0 0 no-repeat';
					document.body.style.backgroundPosition = left + 'px ' + top + 'px';
				}
			break;
			case 'opera':
				{
					var b = document.getElementById('background');
					b.className = 'bum' + Math.round(Math.random() * 100);
					b.style.backgroundImage = 'url(' + image + ')';
					b.style.backgroundRepeat = 'no-repeat';
					b.style.backgroundPosition = left + 'px ' + top + 'px';
				}
			break;
		}
	},
	
	restoreBackground: function() {
		//var b = this.background;
		//this.setBackground(b.image, b.width, b.height, b.left, b.top);
		this.setBackground(this.background);
	},
	
	setSize: function(width, height) {
		switch(this.owner.platform.name) {
			case 'sidebar':
				{
					var s = document.body.style;
					s.height = height + 'px';
					s.width = width + 'px';
					//var b = document.getElementById('background');
					//b.src = b.src;
					
					//window.resizeTo(width, height);
					//if(this.background)
					//	this.setBackground(this.background.image,this.background.width, this.background.height)
					/*
					var b = document.getElementById('background');
					//b.removeObjects();
					//b.addImageObject(image, width, height);
					b.src = 'url(' + this.background + ')';
					*/
				}
			break;
			case 'opera':
				//if(this.owner.platform.os != 'windows')
					window.resizeTo(width + 30, height + 30);
			break;
			case 'dashboard':
				window.resizeTo(width, height);
			break;
		}
	},
	
	prepareForTransition: function(transition) {
		switch(this.owner.platform.name) {
			case 'sidebar':
				//System.Gadget.beginTransition();
			break;
			case 'dashboard':
				widget.prepareForTransition(transition);
			break;
		}
	},
	
	performTransition: function() {
		switch(this.owner.platform.name) {
			case 'sidebar':
			{
				//setTimeout(function () {System.Gadget.endTransition(System.Gadget.TransitionType.morph, 0.2);}, 500);
				//System.Gadget.endTransition(System.Gadget.TransitionType.morph, 3);
			}
			break;
			case 'dashboard':
			{
				function process() {widget.performTransition();}
				setTimeout(process, 50);
			}
			break;
		}
	}
});
