y5.require('URL', function() {

var VOID = y5.VOID;

/**
 * Base class for performing Ajax requests.
 * @constructor
 * @deprecated
 * @param {Object} Ajax object (AjaxIframe, AjaxJS ...)
 * @param {String} Request URL
 * @param {Function} Function handler for success
 * @param {Function} Function handler for error
 * @param {Object} Trace
 * @param {String} Request method (POST, GET)
 * @param {Object} Request body (for POST method only)
 */
y5.Ajax = function(ajax, url, responseSuccess, responseError, trace, method, body) {
    // hack
    if (y5.AjaxForm && (ajax instanceof y5.AjaxForm)) {
        body = ajax.form;
        ajax = new y5.Request.Form(url, {method: method || 'post'});
    } else {
        ajax.url = new y5.URL(url);
        ajax.params.method = (method || 'get').toLowerCase();
    }
    ajax.onload = function(req) { (responseSuccess || VOID)(req.responseText, trace) };
    ajax.onerror = function(err) { (responseError || VOID)(trace, err) };

    this.ajax = ajax;
    this.body = body || null;
};

y5.Ajax.prototype = {
    /**
     * Send request.
     */
    send: function() {
        this.ajax.send(this.body);
    },

    /**
     * Abort request.
     * @alias y5.Ajax.abort
     */
    abort: function () {
        this.ajax.abort();
    }
};

y5.loaded('Ajax');

});