y5.require('Strings', function() {

// !!!: not tested
function SearchHandler(input, highlighters)
{
    this.input = input;
    if (!this.input) {
        return;
    }

    this.highlighters = highlighters;
    if (!this.highlighters) {
        return;
    }

    this.cur_value = '';
    this.interval_id = null;
    this.interval_jump = null;

    var _this = this;
    function listener(evt)
    {
        window.scrollTo(0, 0);
        window.clearTimeout(_this.interval_id);
        _this.interval_id = window.setTimeout(function() {_this.setHightLight()}, 200);
    }

    this.event = new AEventListener(is_ie ? 'keyup' : 'keypress', listener, this.input, true);

    this.addEvent = function()
    {
        this.event.add();
    };

    this.removeEvent = function()
    {
        this.event.remove();
    };

    this.setHightLight = function(nojump)
    {
        if (this.cur_value == this.input.value) {
            return;
        }
        window.clearTimeout(this.interval_jump);
        var first_node = null;

        // Io -> Ie
        var value = IoToIe(this.input.value);

        for (var i = 0, l = this.highlighters.length; i < l; i++) {
            var found = this.highlighters[i].process(value);
            if (!first_node && found) {
                first_node = found;
            }
        }
        if (first_node != null && typeof(nojump) == UNDEF) {
            this.interval_jump = window.setTimeout(function() {_this.jumpFirstNode(first_node)}, 1000);
        }
        this.cur_value = this.input.value;
    };

    this.jumpFirstNode = function(elem)
    {
        var y = scrollToView(elem);
        if (y > Document.clientHeight) {
            this.input.blur();
        }
    };
}


function unwrap_text_node(node)
{
    var pn = node.parentNode;
    var text = node.firstChild.nodeValue;

    var prev = node.previousSibling;
    if (prev && prev.nodeType == 3) {
        text = prev.nodeValue + text;
        pn.removeChild(prev);
    }

    var next = node.nextSibling;
    if (next && next.nodeType == 3) {
        text += next.nodeValue;
        pn.removeChild(next);
    }

    pn.replaceChild(document.createTextNode(text), node);
}

y5.HighLighter = function(content, spider)
{
    this.content = content;
    this.spider = spider || new Spider(this.content, this.create_hl_node);
};

y5.HighLighter.prototype =
{
    process: function(word)
    {
        this.remove();

        var first_node = null;
        if (word.length > 1) {
            first_node = this.spider.process(new RegExp(y5.Strings.escapeRegexp(word), 'i'));
            if (first_node != null) {
                first_node.id = 'first_searchword';
            }
        }
        return first_node;
    },

    remove: function()
    {
        this._remove_hl_nodes(this._get_hl_nodes());
    },

    _get_hl_nodes: function()
    {
        var hl_nodes = this.content.getElementsByTagName('span');
        var nodes = [];

        for (var i = 0, l = hl_nodes.length; i < l; i++) {
            if (hl_nodes[i].className == 'searchword') {
                nodes[nodes.length] = hl_nodes[i];
            }
        }

        return nodes;
    },

    _remove_hl_nodes: function(nodes)
    {
        for (var i = 0, l = nodes.length; i < l; i++) {
            unwrap_text_node(nodes[i]);
        }
    },

    create_hl_node: function(text)
    {
        var span_node = document.createElement('span');
        span_node.className = 'searchword';

        var text_node = document.createTextNode(text);
        span_node.appendChild(text_node);

        return span_node;
    }
};

// Email Links Object
function EmailLinks(content, spider)
{
    this.content = content;
    this.spider = spider || new Spider(this.content, this.create_hl_node);
    var re;
    if (is_simple_reg_exp) {
        re = /(^|\b|<)([a-z][a-z0-9\.\-_]*@[a-z0-9][a-z0-9\-\.]*\.[a-z]{2,6})(\s|>|\)|\]|$)/i;
    } else {
        re = createRegexp('((?:mailto:\\s*)|(?:((?:[\\w]+\\s)?[\\w]+)\\s<)(?=[^\\s]+>))?([a-zA-Z0-9][a-zA-Z0-9\\.\\-_]*@[a-zA-Z0-9][a-zA-Z0-9\\-\\.]*\\.[a-zA-Z]{2,6}(\\?([\\w\\.]+=[\\w\\.\\-%]+))?)(>(?!\\2))?');
    }
    this.spider.process(re);
}

EmailLinks.prototype =
{
    create_hl_node: function(text, match)
    {
        var a_node = document.createElement('a');

        var href = '', name = match[2], mail = match[3];

        if (match[4]) {
            mail = mail.replace('?', '&');
            name = '';
        }

        if (name) {
            href = EncodeURIComponent('"' + name + '" <' + mail + '>');
        } else {
            href = mail;
        }

        a_node.href = '/compose?to=' + href;

        var text_node = document.createTextNode(text);
        a_node.appendChild(text_node);

        return a_node;
    }
};

// HTTP Links Object
function HTTPLinks(content, spider)
{
    this.content = content;
    this.spider = spider || new Spider(this.content, this.create_hl_node);
    this.spider.process(/(\w+:\/\/|www\.)[^\s\"<]*[\w\#?\/&=]/i);
}

HTTPLinks.prototype =
{
    create_hl_node: function(text)
    {
        var a_node = document.createElement('a');

        a_node.href = (text.indexOf('www.') == 0) ? 'http://' + text : text;
        a_node.target = '_blank';

        var text_node = document.createTextNode(text);
        a_node.appendChild(text_node);

        return a_node;
    }
};

// Spider Object
function Spider(content, action)
{
    this.content = content;
    this.action = action;
}

Spider.prototype =
{
    process: function(regex)
    {
        this.first_node = null;
        this._process_recurse(this.content, regex);
        return this.first_node;
    },

    _process_recurse: function(node, regex)
    {
        if (node.hasChildNodes) {
            var i, l = node.childNodes.length, childs = new Array(l);
            for (i = 0; i < l; i++) {
                childs[i] = node.childNodes[i];
            }

            for (i = 0, l = childs.length; i < l; i++) {
                this._process_recurse(childs[i], regex);
            }
            delete childs;
        }

        if (node.nodeType == 3 /* text node type */) {
            this._process_text_node(node, regex);
        }
    },

    _process_text_node: function(node, regex)
    {
        var match;

        while (node != null && (match = regex.exec(node.nodeValue))) {
            var obj = this._get_processed_fragment(node.nodeValue, match);
            node.parentNode.replaceChild(obj.node, node);

            node = obj.last;
            if (this.first_node == null) {
                this.first_node = obj.hlnode;
            }
        }
    },

    _get_processed_fragment: function(text, match)
    {
        var word = match[0];
        var index = match.index;
        var len = word.length;
        var left = text.substring(0, index);
        var center = text.substr(index, len);
        var right = text.substring(index + len);

        delete len;

        //var node = document.createDocumentFragment();
        var node = document.createElement('span');
        this._append_text_node_if_need(left, node);

        delete left;

        return {
            'node': node,
            'hlnode': node.appendChild(this.action(center, match)),
            'last': this._append_text_node_if_need(right, node)
        };
    },

    _append_text_node_if_need: function(text, node)
    {
        return text.length ? node.appendChild(document.createTextNode(text)) : null;
    }
};

y5.loaded('HighLighter');

});